#ifndef _DISK_H_
#define _DISK_H_

#include <qdict.h>
#include "sensor.h"

class DiskLoadData {
public:
        DiskLoadData(const QString& name);
	DiskLoadData(const DiskLoadData& ld);
	unsigned long noinfo;
	unsigned long read_io_ops, blks_read;
	unsigned long write_io_ops, blks_written;
	unsigned long noinfo_rate;
	unsigned long read_io_ops_rate, blks_read_rate;
	unsigned long write_io_ops_rate, blks_written_rate;
	unsigned long jiffies;
	QString diskname;
	void clear();
	DiskLoadData& operator+=(const DiskLoadData& ld);
};

class ProcessorSensor;

class DiskSensor : public Sensor {
public:
	void DiskSensor_24();
	DiskSensor();
	virtual ~DiskSensor();
	virtual QString query(const QString& instance, const QString& pin);
	DECLARE_ACCESS_FUNC(noinfo);
	DECLARE_ACCESS_FUNC(read_io_ops);
	DECLARE_ACCESS_FUNC(blks_read);
	DECLARE_ACCESS_FUNC(write_io_ops);
	DECLARE_ACCESS_FUNC(blks_written);
	DECLARE_ACCESS_FUNC(noinfo_rate);
	DECLARE_ACCESS_FUNC(read_io_ops_rate);
	DECLARE_ACCESS_FUNC(blks_read_rate);
	DECLARE_ACCESS_FUNC(write_io_ops_rate);
	DECLARE_ACCESS_FUNC(blks_written_rate);

	int sample();
	void print();
private:
	int disk_nr;             /* disk total number */
	int sample_load_24();
	int sample_load();
	QDict<DiskLoadData> pre_load;  /* previous load */
 	QDict<DiskLoadData> load;      /* current load */
	ProcessorSensor* ps;
};

#endif /* _DISK_H_ */
