#ifndef _MANAGER_H_
#define _MANAGER_H_

#include <qdict.h>
#include <qptrlist.h>
#include "sensor.h"

class OpenedSensor {
 public:
	OpenedSensor(Sensor* s, const QString& i, const QString& m) 
		: sensor(s), instance(i), pin(m) {} 
	Sensor* sensor;
	QString instance;
	QString pin;
};

typedef Sensor*(*CreateSensorFP)();

class SensorManager {
 public:
	SensorManager(); 
	QString query(const QString& q);
	bool validate_handle(const QString& handle);
	Sensor* get_sensor_by_name(const QString& cls);
	static int parse_sensor(const QString& q,
				QString& host, QString& cls, QString& inst, QString& pin);
// private:
	QString do_get(const QString& q);
	QString do_open(const QString& q, bool realloc);
	QString do_recv(const QString& q, bool do_sample=true);
	QString do_close(const QString& q, bool realloc);
	QString do_instance(const QString& q);
	QString do_pin(const QString& q);
	Sensor* SensorFactory(const QString& cls); 
	QDict<Sensor> shared_sensors;
	QPtrList<Sensor> shared_sensors_list;
	QDict<OpenedSensor> opened_sensors;
	QPtrList<Sensor>& get_all_shared_sensors_list();
	QDict<Sensor>& get_all_shared_sensors();

 private:
	Sensor* get_shared_sensor(const QString& cls);
	int create_all_shared_sensors();
	Sensor* load_mod(const QString& file);
	QDict<CreateSensorFP> create_sensor_fps;
};

#endif /* _MANAGER_H_ */
