#ifndef _MEMORY_H_
#define _MEMORY_H_

#include "sensor.h"

class MemoryData {
public:
        MemoryData();
        unsigned long free, used, free_phy, used_phy, free_swap, used_swap;
	unsigned long buffers, cached;
	unsigned long jiffies, page_in, page_out, swap_in, swap_out;
	unsigned long pre_jiffies, pre_page_in, pre_page_out, pre_swap_in, pre_swap_out;
	void swap();
};

class MemorySensor : public Sensor {
 public:
	MemorySensor();	
	virtual ~MemorySensor() {}
	virtual QString query(const QString& instance, const QString& pin);

	DECLARE_ACCESS_FUNC(free);
	DECLARE_ACCESS_FUNC(used);
	DECLARE_ACCESS_FUNC(free_phy);
	DECLARE_ACCESS_FUNC(used_phy);
	DECLARE_ACCESS_FUNC(free_swap);
	DECLARE_ACCESS_FUNC(used_swap);
	DECLARE_ACCESS_FUNC(buffers);
	DECLARE_ACCESS_FUNC(cached);

	DECLARE_ACCESS_FUNC(page_in);
	DECLARE_ACCESS_FUNC(page_out);
	DECLARE_ACCESS_FUNC(swap_in);
	DECLARE_ACCESS_FUNC(swap_out);

	DECLARE_RATE_FUNC(page_in);
	DECLARE_RATE_FUNC(page_out);
	DECLARE_RATE_FUNC(swap_in);
	DECLARE_RATE_FUNC(swap_out);

	virtual int sample();
 private:
	MemoryData md;
	void print();
	int sample_size_24();
	int sample_size();
	int sample_inout_24();
	int sample_inout();
};

#endif /* _MEMORY_H_ */
