#ifndef _PROCESS_H_
#define _PROCESS_H_

#include <qdict.h>
#include <qstring.h>
#include "sensor.h"
extern "C" {
#include "proc/readproc.h"
}

class ProcessorSensor;

class ProcessSensor : public Sensor {
public:
	ProcessSensor();
	virtual ~ProcessSensor();
	virtual QString query(const QString& instance, const QString& pin);
	DECLARE_ACCESS_FUNC(cutime);
	DECLARE_ACCESS_FUNC(cstime);
	DECLARE_ACCESS_FUNC(rss);
	DECLARE_ACCESS_FUNC(size);
	DECLARE_ACCESS_FUNC(resident);
	DECLARE_ACCESS_FUNC(share);
	DECLARE_ACCESS_FUNC(trs);
	DECLARE_ACCESS_FUNC(lrs);
	DECLARE_ACCESS_FUNC(drs);
	DECLARE_ACCESS_FUNC(dt);
	DECLARE_ACCESS_FUNC(vm_size);
	DECLARE_ACCESS_FUNC(vm_lock);
	DECLARE_ACCESS_FUNC(vm_rss);
	DECLARE_ACCESS_FUNC(vm_data);
	DECLARE_ACCESS_FUNC(vm_stack);
	DECLARE_ACCESS_FUNC(vm_exe);
	DECLARE_ACCESS_FUNC(vm_lib);
	DECLARE_ACCESS_FUNC(vsize);
	DECLARE_ACCESS_FUNC(rss_rlim);
	DECLARE_ACCESS_FUNC(min_flt);
	DECLARE_ACCESS_FUNC(maj_flt);
	DECLARE_ACCESS_FUNC(cmin_flt);
	DECLARE_ACCESS_FUNC(cmaj_flt);
	DECLARE_ACCESS_FUNC(nswap);
	DECLARE_ACCESS_FUNC(cnswap);
	DECLARE_ACCESS_FUNC(utime);
	DECLARE_ACCESS_FUNC(stime);

	DECLARE_RATE_FUNC(utime);
	DECLARE_RATE_FUNC(stime);

	virtual int sample();
	void print();
	void print_proc(proc_t*);
	virtual QValueList<QString>& get_instances();
private:
	proc_t* find_proc(const QString& instance, bool from_current = true);
	int build_instances();
	proc_t** pre_pt;  /* previous process table */
	unsigned long pre_jiffies;
 	proc_t** pt;      /* process table */
	unsigned long jiffies;
	ProcessorSensor* ps;
};

#endif /* _PROCESS_H_ */
