#ifndef _SENSOR_H_
#define _SENSOR_H_

#include <qstring.h>
#include <qdict.h>
#include <qvaluelist.h>
#include "pin.h"

class Sensor {
public:
	Sensor(const QString& nm): name(nm){}
	virtual ~Sensor() {}
	QString name;
	virtual int sample() {return 0;}
	virtual QString query(const QString& instance, const QString& pin) = 0;
	QDict<Pin> pins;
	virtual QValueList<QString>& get_instances() {return instances;}
 protected:
	QValueList<QString> instances; /* instance list */

};

#define DECLARE_ACCESS_FUNC(funcname) \
unsigned long funcname(const QString& instance);

#define DECLARE_RATE_FUNC(funcname)             \
unsigned long funcname ## _rate(const QString& instance);

#endif /* _SENSOR_H_ */
