#ifndef _SENSORFILE_H_
#define _SENSORFILE_H_

#include <qcolor.h>
#include <qptrlist.h>

class SavedSensor {
 public:
	SavedSensor(const QString& sensor_name,
		    const QColor& color,
		    double ratio);
	QString toString();
	QColor color;
	double ratio;
	QString sensor_name;
};

class SensorFile {
 public:
	SensorFile() {sensors.setAutoDelete(TRUE);}
	int load(const QString& filename);
	int dump(const QString& filename, int sample_rate,
		 QPtrList<SavedSensor>& sensors);
	QPtrList<SavedSensor> sensors;
	int sample_rate;
};

#endif /* _SENSORFILE_H_ */
